Option Explicit

Global Const NUMREC = 11            ' Number of Records in my array

Type MYTYPE
    Country As String
    Product As String
    Type As String
    Sales As String
End Type

Global MyData(NUMREC) As MYTYPE

Sub DoFillArray (c As Control, FromRow%, FromCol%)

    '------------------------------------------------------------
    ' c is the vsFlexArray control where the data will be added

    Dim i%
    For i = 0 To NUMREC - 1
        ' for each row
        c.Row = FromRow + i

        ' fill out the column data from MyData
        c.Col = FromCol: c = MyData(i).Country
        c.Col = c.Col + 1: c = MyData(i).Product
        c.Col = c.Col + 1: c = MyData(i).Type
        c.Col = c.Col + 1: c = MyData(i).Sales
    Next i

End Sub

Sub DoGetData ()

    MyData(0).Country = "Country"
    MyData(0).Product = "Product"
    MyData(0).Type = "Type"
    MyData(0).Sales = "Sales"

    MyData(1).Country = "USA"
    MyData(1).Product = "Gold"
    MyData(1).Type = "Import"
    MyData(1).Sales = "450"

    MyData(2).Country = "USA"
    MyData(2).Product = "Gold"
    MyData(2).Type = "Export"
    MyData(2).Sales = "15"

    MyData(3).Country = "USA"
    MyData(3).Product = "Silver"
    MyData(3).Type = "Import"
    MyData(3).Sales = "215"

    MyData(4).Country = "USA"
    MyData(4).Product = "Silver"
    MyData(4).Type = "Export"
    MyData(4).Sales = "12"

    MyData(5).Country = "Canada"
    MyData(5).Product = "Silver"
    MyData(5).Type = "Import"
    MyData(5).Sales = "321"

    MyData(6).Country = "Canada"
    MyData(6).Product = "Silver"
    MyData(6).Type = "Export"
    MyData(6).Sales = "812"

    MyData(7).Country = "Canada"
    MyData(7).Product = "Gold"
    MyData(7).Type = "Import"
    MyData(7).Sales = "321"

    MyData(8).Country = "Canada"
    MyData(8).Product = "Gold"
    MyData(8).Type = "Export"
    MyData(8).Sales = "812"

    MyData(9).Country = "Germany"
    MyData(9).Product = "Gold"
    MyData(9).Type = "Import"
    MyData(9).Sales = "81"

    MyData(10).Country = "Germany"
    MyData(10).Product = "Gold"
    MyData(10).Type = "Export"
    MyData(10).Sales = "-92"

End Sub

Sub DoGridTitles (c As Control)

    Dim i%
    '-------------------------------------------------
    ' initialize grid

    c.ColWidth(0) = c.ColWidth(0) / 2
    c.Col = 0
    For i = 1 To c.Rows - 1
        c.Row = i
        c = i
    Next
    c.Row = 0
    For i = 1 To c.Cols - 1
        c.Col = i
        c = Chr$(64 + i)
    Next
    c.Col = 1
    c.Row = 1
    c.Refresh

End Sub

